<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 9</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/b1lizards.gif">

<CENTER><H1>Cours/TD - (9)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres8.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres10.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>7.12.99</FONT></H3>
<p>


<H2>Cours</H2>

<H3>Positions des lexèmes dans le flot d'entrée. Introduction</H3>

Les langages de programmation modernes aiment le "format libre": les espaces, les changements de ligne ne jouent aucun rôle syntaxique ni sémantique (et un petit rôle lexical : coupent les lexèmes). Cependant parfois les espaces blancs <B>sont</B> importants, si le langage prévoit quelques règles du <SPAN class=ib>layout</SPAN>. En Haskell l'indentation est importante. Si la ligne suivante est plus indentée que son prédécesseur, ceci signifie la continuation de la même structure syntaxique. (Si ceci est impossible, le système ajoute automatiquement le caractère <TT>"{"</TT>. La même indentation est le signe de la continuation colatérale d'une structure, par exemple une nouvelle définition locale sous <TT>let</TT>, une nouvelle clause dans <TT>case</TT> ou dans une définition de fonction, etc. 
On peut imaginer que dans ce cas le système ajoute un caractère de séparation : <TT>";"</TT> après la fin de ligne précédente.

<p>

L'indentation négative (relative) signifie la fin de la structure syntaxique, et peut impliquer l'ajout automatique du caractère <TT>"}"</TT>.
<p>

Ansi les règles du layout deviennent optionnelles, l'utilisateur peut lui-même mettre les points-virgules, etc. Normalement on ne le fait pas.
(Les détails sont décrits dans la documentation. D'ailleurs, l'implantation de quelques petites règles du layout est un bon sujet d'examen...)

<p>

Par contre, le format d'un langage assembleur typique est souvent un peu figé. On trouve d'abord l'étiquette, si le premier caractère de ligne est différent de l'espace, ensuite viennent : le code, les paramètres, etc.

<p>
<CENTER><hr width=70% size=6></CENTER><p>

Mais la reconnaissance de la "position courante" pendant le parsing peut être beaucoup plus importante : ceci permet de localiser les erreurs dans le programme ! Essayons donc de construire un utilitaire de parsing qui augmente la fonctionalité du scanneur lexical en récupérant l'information positionnelle. Il faut que ceci soit plus ou moins transparent, on ne doit pas - si possible - "re-bricoler" les définitions existantes. 
<p>

En principe nous pouvons faire tout avec les parseurs existants. Chaque parseur est augmenté par un compteur <B>(Ligne,Colonne)</B>, et la lecture de chaque caractère modifie ce compteur. Un caractère "normal" incrémente le numéro de colonne, le caractère "\n" incrémente la ligne et remet à zéro la colonne. <SPAN class=ib>Le contenu du compteur est attaché à chaque résultat retourné par le parseur</SPAN>. Ceci est un bon exercice, mais pénible et inefficace, car s'il faut passer ce compteur avec <I>chaque</I> résultat, on génère beaucoup de "miettes". 
<p>

Il faut séparer ce compteur du flot des résultats.
Dans un langage impératif la solution est naturelle, on a une procédure de lecture qui gère un compteur global <B>(L,C)</B>. Dans la programmation fonctionnelle la même solution "naturelle" s'impose, à  savoir :on attache les valeurs qui positionnenet le "curseur de lecture" <I>directement au flot d'entrée</I>, de les considérer comme une partie d'"état" du système. Ainsi les constructions monadiques cachent cette dépendance entièrement, et les parseurs ne subissent aucune (ou presqu'aucune) modification. Mais il faudra généraliser le type du Parseur Universel :

<UL>
<LI> Ce sera un objet un peu plus général, <SPAN class=ib>mais également plus restreint</SPAN> que <TT>UParser</TT> défini précédemment. Rappelons que le type de la fonction du parsing actuel est <TT>([c] -&gt; [(a,[c])])</TT>, où <TT>[c]</TT> la liste des items, par exemple - caractères. Ceci peut être généralisé à <TT>(Int,Int,[c])</TT>, où les deux entiers dénotent la ligne et la colonne courante.
<LI> Le type <TT>a</TT> du résultat peut (parfois doit) inclure la position de l'objet parsé. (Ligne et colonne de son premier caractère).
</UL>
D'autre part, sachant que normalement on a besoin de numéro de ligne/colonne lors de l'analyse lexicale du texte-source, et pendant les étapes ultérieures cette information est redondante, nous pouvons restreindre <TT>UParser</TT> aux chaînes de caractères. Voici une "maquette lexicale" conçue uniquement pour exposer la technique de stockage des informations positionnelles. L'opérateur du parsing aura la forme <TT>(-:&gt;)</TT>, et le nouveau parseur/scanneur est parametré uniquement par le type du résultat ; le type d'entrée est figé.
<PRE>
type Strm = ((Integer,Integer),String)

infix 0  -:&gt;
newtype Scanner a = Sc (Strm -&gt; [(a,Strm)])
Sc p -:&gt; inp = p inp

instance Monad Scanner where  -- Aucune différence
 fail s = Sc (\_ -&gt; [])
 return x = Sc (\inp -&gt; [(x,inp)])
 Sc p &gt;&gt;= f = 
  Sc (\inp -&gt; concat [(f v) -:&gt; out|(v,out)&lt;-p inp])

<SPAN class="bc">--Gestion du compteur</SPAN>
cntpos l c x = case x of
  '\n' -&gt; (l+1,0)
  '\t' -&gt; (l,c+8)
  _    -&gt; (l,c+1)
</PRE>
Le parseur
<PRE>
ppos = Sc (\inp@(p,_) -&gt; [(p,inp)])
</PRE>
récupère la position courante, et retourne-la comme résultat, sans déplacer le curseur de lecture. Le parseur
<PRE>
item = Sc (\inp -&gt; case inp of
            (_,[]) -&gt; []
            ((l,c),(x:xq))-&gt;[(x,(cntpos l c x,xq))])
</PRE>
récupère le premier item (caractère), et assure la mise-à-jour du compteur. Nous pouvons à présent profiter de tous les combinateurs connus, et introdire quelques abbréviations, comme <TT>a $&gt; b = seqp (,) a b</TT> - pour combiner un lexème avec sa position. Le parseur
<PRE>
mot = blanks &gt;&gt; ppos $&gt; many letter
</PRE>
appliqué au
<PRE>
dat = ((0,0), "  Belle marquise, vos 123 yeux ...")
</PRE>
récupère le mot "Belle" avec sa position (0,2), et positionne le compteur.
<p>

Pour pouvoir tester si cela marche, il serait utile <EM>enfin</EM> de présenter la lecture/écriture des fichiers en Haskell (Hugs).
<p>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif"></CENTER><p>


<H3>La Monade IO (entrées-sorties)</H3>

<SPAN class=ib>Attention,</SPAN> sujet assez fatigant (vous verrez que ceci est vraiment simple, seulement long). Question: comment effectuer la lecture, ou l'écriture d'un fichier, etc. sans avoir recours aux effets de bord, qui sont banis par notre sectarisme fonctionnel? La discipline fonctionnelle de programmation peut paraître - à juste titre - une camisole de force, qui empêche des choses souvent utiles et raisonnables, et en tout cas - traditionnelles. Comment remplacer "read" or "write"? L'écriture paraît <I>presque par définition</I> un effet de bord, on modifie le "monde extérieur", on bloque l'imprimante et provoque l'infarctus chez le directeur du département, ou ...
<p>

Mais ceci n'est pas grave, puisque de point de vue du programme un tel "effet de bord" est invisible. On peut imaginer une fonction, disons <TT>putString</TT> qui prend une chaîne, effectue son affichage, et rend rien d'intéressant (la chaîne elle même, ou <TT>()</TT>, ou la chaîne vide, etc.). <SPAN class=ib>La seule question essentielle à laquelle il faudra répondre est : comment incorporer l'usage de la fonction <TT>putString</TT> dans d'autres fonctions du programme, et comment enchaîner plusieurs écritures dans un programme itératif</SPAN>. Par exemple, dans quel ordre sera exécuté l'affichage ici : <TT>fct (putString ()) (putString ())</TT>?...
<p>


Lecture est encore plus délicate. En principe c'est une opération très facile, on peut imaginer que l'appel <TT>getString ()</TT> ou <TT>getString "nom_fichier"</TT> retourne la valeur lue. Mais êtes-vous sûrs quel est le résultat du <TT>fction (getString()) (getString())</TT> ? Lecture et écriture sont est séquentielles, et le protocole des appels fonctionnels - non (et dans un langage paresseux la situation est encore pire ; dans un langage strict comme Scheme on peut toujours s'appuyer sur le principe "de gauche à droite). Mais il y a d'autres moyens.
<p>

On peut considérer qu'un fichier est un flot (<EM>paresseux</EM>) de caractères, consommés comme les éléments d'une liste quelconque. On définit par exemple une fonction, disons <TT>fileContents</TT> qui prend le nom du fichier en argument et qui retourne le contenu sous forme de chaîne. Ceci en Hugs est relativement facile, mais <SPAN class=ib>volontairement tordu</SPAN>. La définition de notre fonction <TT>fileContents</TT> demande le chargement d'un module d'extension, et lancement d'une fonction considérée "dangereuse", <TT>unsafePerformIO</TT> :
<PRE>
:load IOexts.hs

fileContents nom_fichier = unsafePerformIO (readFile nom_fichier)
</PRE>
Ainsi le programme qui lit un fichier et effectue le traitement de son contenu peut être complètement fonctionnel. La sémantique paresseuse nous permettra d'opérer sur les chaînes très longues, voire infinies (p. ex. un flot dynamique envoyé par une <I>pipe-line</I>, ou d'un <I>socket</I> réseau). On peut imaginer l'application du même principe pour l'écriture - on forme une chaîne de sortie unique pour chaque fichier, et l'opération de sortie est exécutée <I>une seule fois</I>, il n'y a pas de problèmes avec la sérialisation.
<p>

Le lecteur peut se poser une de ces deux questions:
<UL>
<LI> Qu'est-ce que tout ceci a à voir avec la compilation?
<LI> Est-il correct de maltraiter les étudiants avec l'approche "académique", fonctionnelle aux entrées/sorties, au lieu d'utiliser des techniques plus simples, comme la lecture d'un buffer par les commandes impératives?
</UL>
Mais si nous nous occupons de la compilation, nous devons envisager une vision très propre de la sémantique des programmes, nous pouvons même vouloir <EM>prouver</EM> quelque chose par des moyens formels. Le compilateur d'un certaine façon est obligé de prouver que le programme compilé soit correct. Au moins syntaxiquement, cela va de soi, mais la "santé sémantique" est aussi importante. Un programme ne doit pas se planter par une simple erreur de division par zéro, par exemple, et il doit se comporter de manière robuste vis-à-vis les opérations d'entrée/sortie. Donc, une vision fonctionnelle de ces opérations nous permet leur analyse plus facile. Ceci devient encore plus important pour l'analyse ou la validation des programmes concurrents.
<p>

Il y a d'autres fonctions comme l'ouverture d'un fichier, passage de son descripteur à une fonction, la commande de l'écriture à la fin du fichier '"append"), le "seek" (lecture positionnée), l'echo, etc. Tout ceci doit être sain et propre. Mais même la simple lecture réalisée comme suggérée ci-dessus par <TT>fileContents</TT> <SPAN class=ib>constitue</SPAN> un danger. La chaîne retournée par <TT>fileContents</TT> peut être <I>très longue</I>, plusieurs millions de caractères ou octets. On ne doit pas la traiter de manière quelconque, mais plutôt de façon incrémentale, consommer quelques caractères, et les "oublier", ne jamais garder la chaîne intégrale après la consommation de sa tête, sinon le programme explosera, la chaîne paresseuse va s'instancier dans sa totalité et débordera la mémoire ! Si on garde une discipline de consommation sériale, exactement comme dans la consommation des items par un enchaînement de parseurs, le danger est évité (ou diminué ; le droit de chaque programmeur de faire n'importe quoi et de semer la pagaille partout reste intact). De plus, si notre liberté de traiter le fichier comme une chaîne est totale, nous pourrons dupliquer cette chaîne et opérer avec plusieurs instances simultanément. Si une de ces instances est instantiée, et consommée, les autres ne peuvent pas rester paresseuses, car tout correspond au même tampon d'entrée. Donc on doit introduire un protocole plus sûr, et la réponse - naturellement - est fournie par les Monades.
<p>

Imaginez que le "monde extérieur", les tampons, descripteurs de fichiers, etc. forment un type de données opaque pour le programme, géré par la couche "magique" de la machine, et non pas par le code de l'utilisateur. Ceci est le cas de programmation dans n'importe quel langage évolué - la totalité de gestion du système de fichiers appartient au système d'exploitation. Appelons ce "type abstrait" : <B>IO</B> (<I>Input/Output</I>). Les opérations dans notre programme qui touchent les objets de ce type sont des "calculs" monadiques. La lecture d'une valeur se réduit à l'usage d'un type monadique qui "emballe" son résultat - justement, la valeur lue. Par contre, l'écriture est un calcul qui ne "possède aucune valeur", tout sort vers le monde extérieur.
<p>

Alors le constructeur IO est capable de générer plusieurs types monadiques concrets <TT>IO a</TT>. Par exemple le type <TT>IO String</TT> est un "calcul d'entrées" qui "possède" (ou génère) un résultat, une valeur de type chaîne de caractères, et <TT>IO ()</TT> est une Monade de sortie. La fonction <TT>readFile</TT> possède le type
<PRE>
readFile :: FilePath -&gt; IO String
</PRE>
où <TT>FilePath</TT> est tout simplement un String, la chaîne qui dénote le nom du fichier.
<p>

Alors, <TT>readFile</TT> "emballe" le continu du fichier, cette chaîne qui risque d'être longue, dans un "containeur" monadique, <TT>IO</TT>. Quelle est la différence par rapport à notre <TT>fileContents</TT> qui fournissait une chaîne? Avec les monades nous écrirons
<PRE>
readFile "fichier" &gt;&gt;=\s -&gt; ...
</PRE>
et nous pouvons faire avec <TT>s</TT> ce que nous voudrons, non?
<p>
<hr width=25%>
<p>
<B>Si.</B>
<p>

<B>En fait... Non. Pas vraiment...</B>
<p>

Rappelons nous que la fonction qui figure à droite du <I>bind</I>, <SPAN class=ib>doit retourner un objet monadique</SPAN>, une autre entité du type <TT>IO ...</TT>. On peut faire presque tout, mais nous continuons le calcul dans le "monde monadique", et il faut respecter le protocole d'enchaînement.
<p>

Nous pouvons y rester jusqu'à la fin du programme. Voulez vous afficher un fichier sur l'écran? Rien de plus facile :
<PRE>
readFile "mon.fichier" &gt;&gt;= putStr
</PRE>
le <I>bind</I> récupère la chaîne qui est le contenu du fichier. La fonction <TT>putStr</TT> est "un peu magique", mais "moins magique" que <TT>putstring</TT> en "C". Elle possède le type <TT>putStr :: String -&gt IO ()</TT>. La valeur retournée n'a pas d'importance, elle est "bidon": <TT>()</TT>. Ce qui compte, c'est ce "flot événementiel", extérieur, en dehors de contrôle du programme. L'effet est simple - le contenu du fichier est affiché. Mais <SPAN class=ib>en dehors de cette chaîne monadique nous n'avons aucun accès à la chaîne</SPAN> qui représente le fichier. Dès que l'on quitte le protocole monadique, tous les liens avec les données qui participent dans le jeu E/S sont rompus. L'exception à cette règle est la fonction <TT>unsafePerformIO</TT>, et pour cela elle est considérée dangereuse.
<p>

Alors : pourquoi ne pas utiliser les fonctions normales, <TT>read "fichier"</TT> qui retourne le caractère suivant, ou <TT>write "fichier" <I>données</I></TT> dont le résultat est <TT>()</TT>, et qui génère l'effet de bord standard, le remplissage du tampon extérieur? Ceci <EM>est</EM> possible, et répétons - en Scheme c'est la stratégie utilisée. Mais avec les monades la sécurité est mieux assurée, et nous pouvons combiner les monades IO avec les parseurs, "pretty-printers", gestion d'erreurs etc. de manière plus comfortable et rassurante. On commence à utiliser les E/S monadiques en Prolog, et même en Java ... ce ne sont pas les jouets des fonctionnalistes fous.
<p>

<EM>Il faut savoir que les opérateurs <SPAN class=ib>bind</SPAN> et <SPAN class=ib>return</SPAN> dans la monade IO sont primitifs, indéfinissables, car l'état du système des E/S n'est pas accessible à l'utilisateur.</EM>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif"></CENTER><p>

<H3>Annexe. Quelques fonctions IO de Haskell (Hugs)</H3>

Vous en aurez - éventuellement - besoin pour votre devoir. Je profite de cette occasion pour introduire une syntaxe spéciale en Haskell qui facilite l'usage des fonctions monadiques ; la "pollution" d'un programme par <TT>(&gt;&gt;=)</TT> devient vite un peu rébarbative...
<p>

La construction de genre:
<PRE>
do a &lt;- alpha
   b &lt;- beta
   ...
   z &lt;- zeta
   ...
   return gamma
   ... autre "commande", p. ex. do {...} interne
</PRE>
est équivalente à l'enchaînement
<PRE>
alpha &gt;&gt= \a -&gt; beta &gt;&gt;= \b -&gt;  ... -&gt; ... return gamma ...
</PRE>
Ceci montre qu'il est possible de programmer en Haskell en style presque impératif, mais la sémantique de la construction <TT>do</TT> reste purement fonctionnelle. Par exemple, une fonction qui affiche un invite, lit une ligne de caractères, effectue son parsing - séparation en mots, et affiche le résultat, peut être codée de manière standard :
<PRE>
putStr "x: " &gt;&gt; getLine  &gt;&gt;= \l -&gt; return (mots l)
</PRE>
ou, différemment :
<PRE>
do putStr "x: "
     l &lt;- getLine
     return (mots l)
</PRE>
Voici la définition de la fonction getLine
<PRE>
getLine   :: IO String
getLine = do c &lt;- getChar
  if c=='\n' then return "" 
             else do cs &lt;- getLine
                     return (c:cs)
</PRE>
De tels objets comme <TT>getLine</TT> ou <TT>getChar</TT> ne sont pas des fonctions, ils ne prennent aucun paramètre. Le programmeur peut demander la "valeur" de cet objet en tapant : <TT>getchar</TT> .
<p>

... et cette valeur lui sera donnée, mais pas tout de suite. L'interprète s'arrête et attend qu'on tape un caractère. Ensuite il affiche le caractère, mais ceci n'est pas la veleur retournée, seulement l'écho du caractère tapé (sauf si cet écho a été désactivé par une commande qui appartient aux extensions du système IO). Ensuite le système retourne la valeur et son type :
<PRE>
 :: IO Char
</PRE>
C'est-à-dire seulement le type, car la valeur n'est pas affichable. <TT>getLine</TT> se comporte de la même façon. Pour pouvoir faire quelque chose avec la chaîne lue, il faut la passer à une autre fonction, par exemple <TT>getLine &gt;&gt;= putStr</TT>
<p>

Hugs possède dans son Prélude et dans les extensions plusieurs fonctions et commandes IO comme <TT>getContents</TT>, <TT>writeFile</TT>, <TT>appendFile</TT>, <TT>interact</TT>, etc. Il est équippé également avec une bonne collection d'analyseurs lexicaux primitifs qui construisent les nombres, etc. Profitez-en pour votre devoir.
  
<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif"></CENTER><p>

<p>
<H2>TD</H2>
<p>


<H3>Un analyseur lexical typique</H3>

<H4>Lexèmes</H4>

Nous savons déjà (plus ou moins) qu'est-ce qu'un lexème dans un langage de programmation typique. les nombres, les identificateurs, opérateurs, séparateurs, etc. - tout ceci doit maintenant être placé dans le même type de données, le type <TT>Lexeme</TT> qui spécifiera le résultat de l'analyse lexicale, le résultat de l'applicatation du parseur <TT>lscan</TT> au flot de caractères. Ensuite l'application du parseur <TT>many lscan</TT> construit la liste de lexèmes qui peut subir les transformations suivantes, et finalement devenir un code optimisé. Définissons donc notre type (maquette) comme
<PRE>
data Lexem = Id String | Inb Int | Lpar | Rpar | Op String 
   | Comma | Semic | Lbrack | Rbrack | Quote | Dquote 
   | Bslash | Lbrace | Rbrace | Bar   deriving (Eq, Show)
</PRE>
Rappelons quelques définitions déjà connues, et transformons-les en parseurs qui fournissent les lexèmes légaux. Nous aurons besoin de quelques fonctions génériques, comme par exemple le prédicat qui vérifie l'appartenance d'un caractère à une liste, etc.
<p>

<H4>Quelques itérateurs en Haskell</H4>

Présentons d'abord quelques techniques de construction de fonctions génériques (universelles) qui sont exploitées souvent dans le Prélude standard (que vous connaissez très bien, ce qui vous serà <EM>indispensable</EM> durant l'examen). Les opérateurs <TT>(&amp;&amp;)</TT> ("ET" logique) et <TT>(||)</TT> ("OU") peuvent être facilement itérés. La fonction <TT>any</TT> définie ci-dessus vérifie si au moins un élément de la liste est vrai, et la fonction <TT>all</TT> - si tous les éléments sont vrais.
<PRE>
and        = foldr (&amp;&amp;) True
or         = foldr (||) False
</pre>
Rappelons seulement que
<PRE>
foldr f z []      = z
foldr f z (x:xs)  = f x (foldr f z xs)
</PRE>
est une fonctionnelle qui trransforme une liste <TT>[a,b,c,d,...m]</TT> en
<TT>f a (f b (f c (f ... (f m z)...)))</TT>.
<P>

Dans un langage paresseux dès que la réponse est fixée par les règles logiques, on n'est plus obligé de chercher plus loin. L'itération <TT>or</TT> s'arrête quand la première valeur vraie est trouvée, et <TT>and</TT> - après la première valeur fausse. Ces prédicats sur des listes permettent les constructions des fonctions qui vérifient si au moins un, ou tous les éléments d'une liste satisfont une condition logique <TT>b</TT>
<PRE>
any b      = or  . map b
all b      = and . map b
</PRE>
ce qui nous permet aisément de définir la fonction <TT>elem</TT> testant l'appartenance d'un objet à une liste :
<PRE>
elem              = any . (==)
notElem           = all . (/=)
</PRE>
Cool, non? (Mais si quelqu'un n'a toujours pas approvoisé la composition fonctionnelle <TT>(.)</TT>, ceci risque la peine capitale, et je ne plaisante pas !)
<p>

<H4>Blanks</H4>
Je vous ai proposé de construire le parseur <TT>blanks</TT> absolument minimal, c'est-à-dire un parseur qui ne construit <I>aucune structure de données</I> accessoire, aucune liste. On consomme à peine les caractères depuis le flot d'entrée. Le but de cette section est strictement accessoire, nous voulons montrer comment faire des optimisations de bas niveau dans le domaine des parseurs, et d'éviter le gaspillage de mémoire.
<p>

On peut utiliser <TT>item</TT> ou <TT>sat</TT> (ou <TT>literal</TT>), mais l'usage de <TT>many</TT> est interdit ; nous ne voulons pas de créer des listes. Nous pouvons même de renoncer de stocker l'item élémentaire, et au lieu de <TT>sat</TT> utiliser le parseur <TT>found b</TT>, où <TT>b</TT> est une condition logique :
<PRE>
found b = Sc (\((l,c),(x:xq)) -&gt;
    if b x then [((),(cntpos l c x,xq))]) else [])
</PRE>
Il est inutile d'enchaîner un tel parseur avec <I>bind</I>, puisque le résultat n'a aucune importance, et ce n'est pas la peine de le récupérer. Au lieu de <TT>(&gt;&gt=)</TT> ou <TT>(&gt;&gt)</TT> nous utiliserons un autre opérateur infixe <TT>(&gt;-&gt)</TT>, défini
par :
<PRE>
Sc p &gt;-&gt; Sc q = 
  Sc (\inp -&gt; concat [q out|(_,out)&lt;-p inp])
</PRE>

Commençons par un prédicat qui vérifie si un caractère appartient à l'ensemble des caractères blancs, et le parseur correspondant :
<PRE>
isBlank c = elem c [' ','\t','\n']
blank = sat isBlank
</PRE>
Mais l'itération, qui enfin ne retourne rien, utilise un autre itérateur que <TT>many</TT> :
<PRE>
xmany p = p &gt;-&gt; xmany' p
xmany' p = p &gt;-&gt; xmany' p # return ()
</PRE>
et le parseur <TT>blanks</TT> peut être défini comme suit :
<PRE>
blanks = xmany' isBlank
</PRE>
<p>

<center><hr size=6 width=75%></center>
<p>
<H4>Finalement, le scanneur</H4>

Voici les parseurs pour les identificateurs et les nombres :
<PRE>
chiffre = digit &gt;&gt;= \c -&gt; return (ord c - ord '0')
integ = chiffre &gt;&gt;= numlist
numlist n = (chiffre &gt;&gt;= \m -&gt; numlist (10*n+m)) # return (Inb n)

ident = (letter +&gt; many' alphanum) &gt;&gt;= \x -&gt; return (Id x)
</PRE>
Les opérateurs sont composés de caractères spéciaux, mais leur liste est restreinte, les parenthèses, etc. sont interdites. Voici un filtre possible de caractères opérationnels :
<PRE>
opChar x = elem x "+-*/&lt;&gt;=|&amp;#~^@%!?:,."
</PRE>
Il nous permettra de construire un parseur générique des opérateurs :
<PRE>
oper = many opChar &gt;&gt;=\s -&gt; return (Op s)
</PRE>
Quelques objets lexicaux sont sécifiques et uniques : parenthèses, point-virgule, "\", etc. Voici quelques parseurs utiles :
<PRE>
isa obj cns = 
  item &gt;&gt;= \x -&gt; if obj==x then return cns else fail []

lpar = isa '(' Lpar
rpar = isa ')' Rpar
comma = isa ',' Comma
bar = isa '|' Bar
lbrack = isa '[' Lbrack
rbrack = isa ']' Rbrack
semic = isa ';' Semic

quote = isa '\'' Quote
bslash = isa '\\' Bslash

</PRE>
etc. Tout ensemble peut être réalisé par le parseur suivant, qui accessoirement avale les espaces initiaux :
<PRE>
token = blanks &gt;&gt; (foldl xor (fail [])
   [ident, integ, oper, lpar, rpar, bar, lbrack, rbrack, 
    quote, bslash, semic])

scanner = many token
</PRE>
Le dernier parseur transforme le flot d'entrée : une liste de caractères, en un flot de lexèmes.
<p>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>


<H3>Parsing des expressions algébriques</H3>

Voici le parsing algébrique, déjà vu plusieurs fois, cette fois réalisé de manière monadique. Rappelons la grammaire, transformée par la normalisation de Greibach :
<PRE class=he>
expr ::= terme termlist
termlist ::= EPS | opAdd terme termlist
opAdd ::= '+' | '-'

terme ::= facteur factlist
factlist ::= EPS | mulOp facteur factlist
mulOp ::= '*' | '/'

facteur ::= atome | '(' expr ')'
</PRE>
Voici la structure de données qui représente le résultat, et les parseurs. Ils n'agissent plus sur les listes de caractères, mais sur les listes de lexèmes !
<PRE>
data Expr = Lf Lexem | O Lexem Expr Expr  
            deriving (Eq,Show)
</pre>
Le premier lexème dans la branche "<TT>O</TT>" est l'opérateur. le reste est classique :

<pre>
expr = eterm &gt;&gt;= \cx -&gt; trmlist cx
trmlist cx = (addop &gt;&gt;= \op -&gt; eterm &gt;&gt;= \y -&gt; 
   trmlist (O op cx y)) # return cx
addop = sat (==Op "+") # sat (==Op "-")
</pre>
Notez que le parseur <TT>trmlist</TT> est <SPAN class=ib>parametré</SPAN> : son paramètre est le contexte gauche récupéré de son voisin de gauche, ou passé récursivement par son "père"). Le reste est évident.
 
<pre>
eterm = efact &gt;&gt;= \cx -&gt; fctlist cx
fctlist cx = (mulop &gt;&gt;= \op -&gt; efact &gt;&gt;= \y -&gt; 
   fctlist (O op cx y)) # return cx
mulop = sat (==Op "*") # sat (==Op "/")

efact = (sat (==Lpar) &gt;&gt; expr &gt;&gt;= \r -&gt; 
  sat (==Rpar) &gt;&gt; return r) # atom
</PRE>
Un atome est soit un identificateur, soit un nombre.
<PRE>
atom = sat vdata &gt;&gt;= \r -&gt; return (Lf r)
 where vdata (Id _) = True
       vdata (Inb _) = True
       vdata _ = False
</PRE>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<EM>Attention ! Les exercices sur la longueur de la chaîne, et réconstruction des entiers grâce aux attributs tels que la position du chiffre, seront répétés en cours dans un contexte plus général.</EM>

<TABLE width=100%>
 <TR><TD align=left><A HREF="comres8.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres10.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>




